﻿Imports SolidWorks.Interop.swdocumentmgr

Public Class frmProgress

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Me.Visible = True

        Dim swDoc As SwDMDocument18
        Dim nDocType As SwDmDocumentType = SwDmDocumentType.swDmDocumentPart
        Dim nRetVal As SwDmDocumentOpenError

        pb_Progress.Maximum = frmMain.lbxFiles.Items.Count
        pb_Progress.Value = 0
        For Each sDocFileName As String In frmMain.lbxFiles.Items
            pb_Progress.Value += 1
            lb_Filename.Text = sDocFileName
            swDoc = CType(frmMain.oSwDocMgrCls.GetDocument(sDocFileName, nDocType, False, nRetVal), SwDMDocument18)
            Me.Refresh()
            SetProperties(swDoc)
        Next
        Me.Close()
    End Sub

    Private Sub SetProperties(ByVal swDoc As SwDMDocument18)

        Dim bRet As Boolean

        Try

            If frmMain.rb_yes.Checked Then
                bRet = swDoc.DeleteCustomProperty("IsFastener")
                bRet = swDoc.AddCustomProperty("IsFastener", SwDmCustomInfoType.swDmCustomInfoYesOrNo, "Yes")
            End If

            If frmMain.rb_no.Checked Then
                bRet = swDoc.DeleteCustomProperty("IsFastener")
                bRet = swDoc.AddCustomProperty("IsFastener", SwDmCustomInfoType.swDmCustomInfoYesOrNo, "No")
            End If

            swDoc.Save()
            swDoc.CloseDoc()

        Catch Ex As Exception
            MessageBox.Show("Cannot read file from disk." & Environment.NewLine _
                            & "Maybe future SWX-version, or File is opened in SolidWorks" & Environment.NewLine _
                            & "Original error: " & Ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

End Class